use anyhow::Result;
use std::convert::TryFrom;

pub mod xmas_decoder;
pub mod errors;

static INPUT: &str = include_str!("../../input09");

fn main() -> Result<()> {
    let decoder = xmas_decoder::XMASDecoder::try_from(INPUT)?;

    let missing = decoder.decode().expect("did not find a solution");
    println!("missing: {}", missing);

    let found = decoder
        .find_continues(missing)
        .expect("did not find a solution");
    let sum = found.iter().max().unwrap() + found.iter().min().unwrap();
    println!("sum: {}", sum);

    Ok(())
}

